use sqlx::{PgPool, prelude::FromRow};
use uuid::Uuid;

use crate::models::exercises::ExerciseVariant;

#[derive(Debug, FromRow)]
pub struct Workout {
    pub workout_id: Uuid,
    pub name: String,
    pub description: String,
}

#[derive(Debug, FromRow)]
pub struct WorkoutExercise {
    pub workout_id: Uuid,
    pub exercise_id: Uuid,
    pub exercise_type: ExerciseVariant,
    pub position: i32,
    pub sets: Option<i32>,
    pub reps: Option<i32>,
    pub time: Option<i32>,
}

#[derive(Debug, FromRow, serde::Serialize)]
pub struct WorkoutExerciseFull {
    pub exercise_id: Uuid,
    pub exercise_type: ExerciseVariant,
    pub position: i32,
    pub sets: Option<i32>,
    pub reps: Option<i32>,
    pub time: Option<i32>,
    pub name: String,
    pub description: String,
}
